require 'net/http'
require 'uri'
require 'digest/md5'
require 'fileutils'

module Sec
  module Firms
    class Downloader
      attr_reader :url, :root_path

      def initialize(url)
        @url = url
        @root_path = "#{Sec::Firms.configuration.root_path}/downloads/"
      end

      def content
        if File.exist?(file_name)
          read_file
        else
          save_to_file
        end
      end

      def file_name
        "#{root_path}#{Digest::MD5.hexdigest(url)}.xml"
      end

      private

      def read_file
        IO.read(file_name)
      end

      def save_to_file
        request = Net::HTTP.get_response(URI.parse(url))
        if request.code == '200'
          FileUtils.mkdir_p(root_path)
          File.write(file_name, request.body)
          request.body
        end
      end
    end
  end
end
