module Sec
  module Firms
    class FirmEntryParser < XMLParser
      attr_reader :updated_at

      def initialize(xml_str, updated_at)
        super(xml_str) if xml_str
        @updated_at = updated_at
      end

      def to_hash
        data = Hash.from_xml(doc.to_s)['edgarSubmission']['formData'] rescue nil

        return {} unless data
        data = Helpers::transform_hash(data) do |hash, key, value|
          hash[key] = default_values(value)
        end
      end

      private

      def default_values(value)
        {
          value: value,
          updated_at: updated_at
        }
      end
    end
  end
end
